=== qucs-core/doc/CMakeLists.txt ===

#EXTRA_DIST = PLATFORMS

SET(MANPAGES qucsator.1 qucsconv.1 )

INSTALL(FILES ${MANPAGES} DESTINATION share/man/man1)
