=== debian/control ===
Source: qucs
Section: electronics
Priority: optional
Maintainer: MAYBL8 <dcihon@gmail.com>
XSBC-Original-Maintainer:Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer1: José L. Redrejo Rodríguez <jredrejo@debian.org>
Homepage: http://qucs.sourceforge.net
Build-Depends: debhelper (>= 9),
 autotools-dev,
 libqt4-dev (>= 4.6),
 libx11-dev,
 flex,
 bison,
 gperf,
 adms,
 cmake
Standards-Version: 3.9.5

Package: qucs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adms, iverilog, freehdl, octave
Recommends: qucs-doc
Description: Quite Universal Circuit Simulator
 Qucs is an integrated circuit simulator which means you are able
 to setup a circuit with a graphical user interface (GUI) and simulate
 the large-signal, small-signal and noise behaviour of the circuit.
 After that simulation has finished you can view the simulation
 results on a presentation page or window.
