=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --parallel
	
override_dh_strip:
	dh_strip --no-automatic-dbgsym
